routes/web.php
<?php

Route::get('/', 'HomeController@index')->name('/');

Auth::routes();

//ACL==================================================================================================
Route::get('user/{user}/roles', 'UserController@roles')->name('user.roles')->middleware(['auth','role:Administrador']);
Route::put('user/{user}/roles', 'UserController@rolesSync')->name('user.roles')->middleware(['auth','role:Administrador']);

Route::resource('user', 'UserController');//->middleware(['auth','role:Administrador']);

Route::get('role/{role}/permissions', 'RoleController@permissions')->name('role.permissions')->middleware(['auth','role:Administrador']);
Route::put('role/{role}/permissions', 'RoleController@permissionsSync')->name('role.permissions')->middleware(['auth','role:Administrador']);
Route::resource('role', 'RoleController')->middleware(['auth','role:Administrador']);

Route::resource('permission', 'PermissionController')->middleware(['auth','role:Administrador']);
//======================================================================================================
Route::resource('produto', 'ProdutoController')->middleware(['auth','role:Administrador']);
Route::resource('categoria', 'CategoriaController')->middleware(['auth','role:Administrador']);

Route::get('/carrinho', 'CarrinhoController@index')->name('carrinho.index')->middleware('auth');
Route::get('/carrinho/adicionar', function() {
    return redirect()->route('/');
});
Route::post('/carrinho/adicionar', 'CarrinhoController@adicionar')->name('carrinho.adicionar')->middleware('auth');
Route::delete('/carrinho/remover', 'CarrinhoController@remover')->name('carrinho.remover')->middleware('auth');
Route::post('/carrinho/concluir', 'CarrinhoController@concluir')->name('carrinho.concluir')->middleware('auth');
Route::get('/carrinho/compras', 'CarrinhoController@compras')->name('carrinho.compras')->middleware('auth');
Route::post('/carrinho/cancelar', 'CarrinhoController@cancelar')->name('carrinho.cancelar')->middleware('auth');
Route::post('/carrinho/desconto', 'CarrinhoController@desconto')->name('carrinho.desconto')->middleware('auth');

/*ROTA DE TESTE FEATURE*/
Route::get('routeClosure', function() {
    return 'OK';
});

app/Categoria.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Categoria extends Model
{
    protected $fillable = ['name', 'created_at', 'updated_at'];
}

app/Http/Controllers/CategoriaController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Categoria;

class CategoriaController extends Controller
{
    private $categorias;
    
    public function __construct() {
        $categorias = $this->categorias;
    }
    
    public function index()
    {
        $categorias = Categoria::all();
        return view('categorias.index', compact('categorias'));
    }

    public function create()
    {
        return view('categorias.create');
    }
    
    private function validaForm($request) {
         $validatedData = $request->validate
        ([
            'name' => 'required|max:150'
        ]);
    }

    public function store(Request $request)
  {
      $this->validaForm($request);
      
      $categorias = new Categoria;
      $categorias->name = $request->name;

      $warning ='Registro já cadastrado!';
      $success ='Registro cadastrado com sucesso!';
      return $this->inserting($categorias, $warning, $success);
  }

  public function edit($id)
  {
      $categorias = Categoria::find($id);
      return view('categorias.edit', compact('categorias'));
  }

  function update(Request $request, $id)
  {
      $this->validaForm($request);
     
      $categorias = Categoria::find($id);
      $categorias->name = $request->name;
     
      $warning = 'Registro já existe com esses dados!';
      $success = 'Registro editado com sucesso!';
      return $this->updating($categorias,$warning,$success);

  }

  private function inserting($categorias, $warning, $success)
  {
    $checking = $categorias->where(['name'=> $categorias->name])->exists();

    if($checking === true) {
        $notifications = array('message' => 'Erro ao efetuar o Cadastro!', 'alert-type' => 'danger');
        return back()->with($notifications);
    }else{
        $categorias->save();
        $notifications = array('message' => 'Cadastro efetuado com sucesso!', 'alert-type' => 'success');
        return back()->with($notifications);
    }
  }

  private function updating($categorias, $warning, $success)
  {
    $checking = $categorias->where(['name'=> $categorias->name])->exists();
    if($checking === true) {
        $notifications = array('message' => 'Erro ao atualizar!', 'alert-type' => 'danger');
        return back()->with($notifications);
    }else{
        $categorias->update();
        $notifications = array('message' => 'Cadastro alterado com sucesso!', 'alert-type' => 'success');
        return back()->with($notifications);
    }
  }

  public function destroy($id)
  {
      $categorias = Categoria::find($id);
      $checking = $categorias->where('id',$id)->exists();

      if($categorias->delete()) {
        $notifications = array('message' => 'Cadastro deletado com sucesso!', 'alert-type' => 'success');
        return redirect()->route('categoria.index')->with($notifications);
        }else{
        $notifications = array('message' => 'Erro ao deletar o Cadastro!', 'alert-type' => 'danger');
        return redirect()->route('categoria.index')->with($notifications);
    }

  }
}

resources/views/categorias/create.blade.php
@extends('layouts.layout')

@section('content')
<div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                   <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">CADASTRAR CATEGORIA</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('categoria.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">
                        <form action="{{ route('categoria.store') }}" method="post" class="mt-4" autocomplete="off">
                            @csrf

                            <div class="form-group">
                                <label for="name">Nome da Categoria</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="name" placeholder="Digite uma categoria"
                                       name="name" value="{{ old('name') }}">
                                @if ($errors->has('name'))<span class="form-text help-block msg_validate">{{ $errors->first('name') }}</span>@endif

                            </div>
                            
                            <button type="submit" class="btn btn-success">Cadastrar</button>
                             <a href="{{ route('categoria.index') }}" class="btn btn-info"><i class="fas fa-list"></i> Listar</a>
                            <a href="{{ route('/') }}" class="btn btn-danger"><i class="fas fa-ban"></i> Cancelar</a>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/categorias/edit.blade.php
@extends('layouts.layout')

@section('content')
<div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                   <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">EDITAR CATEGORIA</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('categoria.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">
                        <form action="{{ route('categoria.update', ['categorium' => $categorias->id]) }}" method="post" class="mt-4" autocomplete="off">
                            @csrf
                            @method('PUT')
                            <div class="form-group">
                                <label for="name">Nome da Categoria</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="name"
                                       name="name" value="{{ old('name') ?? $categorias->name }}">
                                @if ($errors->has('name'))<span class="form-text help-block msg_validate">{{ $errors->first('name') }}</span>@endif

                            </div>
                            
                            <button type="submit" class="btn btn-success">Alterar</button>
                             <a href="{{ route('categoria.index') }}" class="btn btn-info"><i class="fas fa-list"></i> Listar</a>
                            <a href="{{ route('/') }}" class="btn btn-danger"><i class="fas fa-ban"></i> Cancelar</a>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/categorias/index.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                  <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">LISTAGEM DE CATEGORIAS</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('categoria.create') }}">&plus; Novo</a></div>
                        </div>
                    </div><br />
                    <div class="card-body">
                        @if (session('status'))
                            <div class="alert alert-success" role="alert">
                                {{ session('status') }}
                            </div>
                        @endif

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <table class="table table-striped mt-4">
                            <thead>
                            <tr>
                                <th>#</th>
                                <th>Nome</th>
                                <th class="th-center">Editar</th>
                                <th class="th-center">Excluir</th>
                            </tr>
                            </thead>
                            <tbody>

                           @forelse($categorias as $categoria)
                           <tr>
                                    <td>{{ $categoria->id }}</td>
                                    <td>{{ $categoria->name }}</td>
                                    <td class="th-center"><a class="btn btn-link" href="{{ route('categoria.edit', ['categorium' => $categoria->id] ) }}">Editar</a></td>
                                    <td class="th-center">
                                        <form action="{{ route('categoria.destroy', ['categorium' => $categoria->id]) }}" method="post">
                                            @csrf
                                            @method('delete')
                                            <input class="btn btn-link" type="submit" value="Remover">
                                        </form>
                                    </td>
                                </tr>
                                @empty
                            <p>Nenhuma categoria cadastrado!</p>
                          @endforelse

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div><br /><br />
@endsection